package com.myoa.engineering.crawl.shopping.domain.model;

import com.myoa.engineering.crawl.shopping.domain.model.v2.ArticleModel;
import lombok.*;

import java.util.List;
import java.util.stream.Collectors;


@ToString
@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class UserNotifyModel {
    private String slackId;
    private List<ArticleModel> articles;

    public static UserNotifyModel of(String slackId, List<ArticleModel> articles) {
        return UserNotifyModel.builder()
                              .slackId(slackId)
                              .articles(articles)
                              .build();
    }

    public String toCompositedMessage() {
        String compositedMessage = wrapUserId() + "\n" +
                articles.stream()
                        .map(this::convertArticletoMessage)
                        .collect(Collectors.joining("\n"));
        // article -> builder.append(convertArticletoMessage.toMessage()).append("\n");i
        return compositedMessage;
    }

    private String wrapUserId() {
        return "<@" + slackId + ">";
    }

    private String convertArticletoMessage(ArticleModel article) {
        return "<" + article.getArticleUrl() + "|" + article.getTitle() + ">";
    }
}
