package com.myoa.engineering.crawl.shopping.controller;

import com.myoa.engineering.crawl.shopping.crawlhandler.CrawlHandler;
import com.myoa.engineering.crawl.shopping.support.dto.constant.CrawlTarget;
import com.slack.api.methods.MethodsClient;
import com.slack.api.methods.SlackApiException;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/api/v1/exploit")
public class TestAPIController {

    private final MethodsClient methodsClient;
    private final List<CrawlHandler> crawlHandlers;


    public TestAPIController(MethodsClient methodsClient, List<CrawlHandler> crawlHandlers) {
        this.methodsClient = methodsClient;
        this.crawlHandlers = crawlHandlers;
    }

    @GetMapping("/triggers")
    public void triggerExploit(@RequestParam("crawlTarget") CrawlTarget crawlTarget) {
        crawlHandlers
                .stream().filter(e -> e.getCrawlTarget().equals(crawlTarget))
                .forEach(CrawlHandler::handle);
    }

    @GetMapping("/test-message")
    public void testMessage() throws SlackApiException, IOException {
        methodsClient.chatPostMessage(req -> req
                .channel("notify_shopping")
                .text("Hello, World!"));
    }
}
